/************************************/
/*	OS Assignment 2
/*	By: Simon Foucher
/*	260 223 197
/************************************/
//460 done 




/************************************/
/*	includes and definitions				
/************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define TRUE 1
#define FALSE 0
#define CONCURRENT 9					// Defines the number of programs that can run at the same time
typedef int BOOL;


/************************************/
/*	Function declarations				
/************************************/
void logo(void);
int interpreter(char commandline[], int Running);


/************************************/
/*	Global Variables & datatypes				
/************************************/
char *FREERAM[100];							//Pointer to RAM array
char *shellMemoryVar[100];
char *shellMemoryData[100];
char userPrompt[40] = ".$ ";
BOOL verbose = FALSE;

int quanta = 3;	                            // We'll give the option to the user to set quanta
                                            // Since CPU interrupted by shell prompt every CPU cycle, 

int readyHead;								// Pointer to the head of the Ready Q
int readyTail;							// Tail pointer of the ready Q 
int readyQ[CONCURRENT];                     // We'll use an array for the ready queue
int terminateQ[CONCURRENT];

struct PCBdef								// Process Control Block Data Structure definition
	{
		char filename[50]; 					// Stores the name of the script loaded into memory
		int start; 						    // Start address loaded into RAM
		int length; 						// Number of instructions
		int current; 						// Current instruction being executed
		char *memory[20]; 					// List of Shell Memory variables and values
		struct PCB *next; 					// Next node in the linked-list
	};


struct cpu
	{
	int quanta; int returnCode;
	int pc;
	char *memory[20];						// Since the PCBs only have 20 memory cells
	};




/*******************************************************************************/
/*	After over 20 hours of fruitless efforts, I came to the conclusion that
/*	I could not implement linked lists for PCB, so instead, the run time
/*	environment has been implemented using int pointers in arrays. The work 
/*	pointers has been left in comment to compare with solutions 
/*******************************************************************************/
struct PCBdef PCB[CONCURRENT];				// Creates 9 PCBs (max threads that can execute at the same time)


/*struct PCB *headReady;					// Pointer to the Head of the REady queue of waiting scripts; declared globally
struct PCB *headTerminate;					// Pointer to the Head of hte queue of scripts that have terminated; declared globally
*/




/************************************/
/*	Functions						
/************************************/



/*******************************************************************************/
/*	New/Modified functions since shell.c are clarly identified.
/*	All other functions are similar to old version
/*******************************************************************************/

BOOL displayMemVar(char commandline[])
{
    int i,j;
    BOOL found = FALSE;
    char variable[50];

    // variable names is the second word

    for(i=3,j=0;i<200 && (commandline[i]!='\0' || commandline[i]!='\0');i++)
      if (commandline[i]!=' ')
      {
          variable[j] = commandline[i];
          j++;
      }

    variable[j]='\0';

    // locate variable in shell memory

    for(i=0;i<100 && shellMemoryVar[i]!=NULL;i++)
    {
        if (strcmp(shellMemoryVar[i],variable)==0)
        {
            found = TRUE;
            printf("%s=%s\n",variable,shellMemoryData[i]);
            break;
        }
    }

    if (!found) {printf("Not found\n"); return FALSE;}

    return TRUE;
}

void stripCRLF(char array[])
{
    int i;

    for(i=0;i<500 && array[i]!='\0';i++)
      if (array[i]=='\r' || array[i]=='\n') array[i]='\0';
}


/*******************************************************************************/
/*	Function setMemVar: Stores variable and value
/*	
/*	Input: 
/*      The command (from RAM or SHELL)
/*      Running: a pointer to memory. If Running = 15; command came from SHELL
/*
/*  Additions:
/*      - Records the variable used by a script to its PCB
/*      - The function blocks scripts form overwrighting variables that are
/*          not part of their PCB (either created by shell or another script
/*      - If a shell command overwrights a variable reated by a script,
/*          a warning is issued but the variable get's overwritten
/*******************************************************************************/





setMemVar(char commandline[],int Running)
{
    char variable[100];
    char data[100];
    char userInput[1];
    int i,j,k;
    BOOL outOfMemory = TRUE;
    int script = TRUE;                                          // Assube that we are interpreting a script be default
    int allowed = TRUE;                                         // To make sure that processes don't overwrite other processes's memory          
    if (Running==15)                                            // If the command came from the shell, Running =15                    
        script = FALSE;                                         // Not scripting, use PCB memory

    // skip white spaces
    for(i=3;i<200 && commandline[i]!='\0' && commandline[i]==' ';i++);

    // copy variable
    for (j=0;i<200 && commandline[i]!='\0' && commandline[i]!=' ';i++,j++)
        variable[j]=commandline[i];

    variable[j]='\0';

    // skip white spaces
    for(;i<200 && commandline[i]!='\0' && commandline[i]==' ';i++);

    // copy data
    for (j=0;i<200 && commandline[i]!='\0' && commandline[i]!=' ';i++,j++)
        data[j]=commandline[i];

    data[j]='\0';


    // Store it into the shell's memory, overwritting wit user approval it if it already exists

    for(i=0;i<100;i++)
    {
        if (shellMemoryVar[i]==NULL) // not in memory so insert and exit
        {
            allowed = TRUE;
            shellMemoryVar[i]  = strdup(variable);
            shellMemoryData[i] = strdup(data);
            outOfMemory = FALSE;
            break;
        }

        else if (strcmp(shellMemoryVar[i],variable)==0)                     // If the variable already exists in Shell memory
        {
           if(script)                                                       // If scripting, make sure we don't overwrite other processes's valriables
                {
                    allowed = FALSE;                                        // Not allowd until proven that variable is in script memory
                            for(j=0;(j<=20 && PCB[Running].memory[j] != NULL);j++)// Scanning internal memory for variable name
                            {                                                       
                                if(strcmp(PCB[Running].memory[j], variable)==0)   // If it's part of the script's memory
                                    {allowed = TRUE;break;}                       // Allow overwright and break
                            }

                    if(!allowed)                                            // Warn user of illegal operation
                      {
                        printf("\nWARNING!!!\nThe script is trying to overwright the variable '%s',\n",variable);
                        printf("which was created by another script or the shell.\n\n");
                        printf("Permission denied and instruction ignored!\n\n");
                      }
                }// End of if scripting

            else if(!script)                                                // If we are not scripting
                {
                    allowed = TRUE;                                         // Allowed to overwright                   
                    for(k=0;k<=9;k++)                                       // Scan all PCBs
                      {
                        for(j=0;(j<=20 && PCB[k].memory[j] != NULL);j++)    // Scan every non empty memory Cells of PCBs
                            {
                              if(strcmp(PCB[k].memory[j], variable)==0)     // If the variable is found in a PCB's memory
                                {                                           // Warn user 
                                    printf("WARNING!!!\nThe variable %s was created by another script.\n",variable);
                                    printf("Overwriting it's value will permanently destroy it's previous value\n");
                                    printf("without warning the script who created it. This might cause the process\n");
                                    printf("to behave abnormally or crash.\nAlso note that the variable will");
                                    printf("be deleted from Shell memory\nwhen that script ends!!\n\n");
                                    break;
                                }// End of displaying warning
                            }// End of scanning every non empty memory cells
                      }// End of scanning every PCBs
                }// End of if !scripting

            if(allowed)                                                     // So if we are allowed to overwright
                {                        
                    free(shellMemoryVar[i]);
                    free(shellMemoryData[i]);

                    shellMemoryVar[i]  = strdup(variable);
                    shellMemoryData[i] = strdup(data);

                    outOfMemory = FALSE;
                    break;
                }
        }// End of if variable already exists
    }

                       
    if(outOfMemory == FALSE && script==TRUE && allowed == TRUE)             // If we are scripting and variable got stored in SHELL memory
        {           
            for(j=0;j<20;j++)                                               // Scan PCB memory cells            
                {
                     if (PCB[Running].memory[j]==NULL)                      // Variable not in memory so insert and exit
                        {
                            PCB[Running].memory[j]  = strdup(variable);
                            break;
                        }
                      else if (strcmp(PCB[Running].memory[j],variable)==0)  // Variable already exists in PCB memory, break
                        break;

                }// End of scanning PCB memory cells
        }// End of out of !outOfmemory & scripting

    // if it was not added to the shell the outOfMemory still TRUE

    if (outOfMemory)
        printf("%s=%s not inserted.  Out of shell memory!\n",variable,data);
}



void changePrompt(char commandline[])
{
    int i,j;
    // variable in the second word

    for(i=6,j=0;i<200 && commandline[i]!='\0';i++)
      if (commandline[i]!=' ')
      {
          userPrompt[j] = commandline[i];
          j++;
      }
    stripCRLF(userPrompt);
    userPrompt[j]   = ' ';
    userPrompt[j+1] = '$';
    userPrompt[j+1] = '\0';
	
}


void execute(char commandline[])
{
    int i,j, errorCode=-1;
    char filename[200];
    char scriptcommand[500];
    FILE *ptr;

    // filename in the second word

    for(i=6,j=0;i<200 && commandline[i]!='\0';i++)
      if (commandline[i]!=' ') 
      {
          filename[j] = commandline[i];
          j++;
      }

    filename[j] = '\0';

    // Verify the file is good

    ptr = fopen(filename,"rt");
    if (ptr == NULL)
    {
        printf("Invalid script file\n");
        return;
    }

    // Process the script file to completion

    fgets(scriptcommand,500,ptr);
    stripCRLF(scriptcommand); // more commonly know as CHOMP
//    errorCode = interpreter(scriptcommand);

    while(!feof(ptr) && errorCode != -1)
    {
        fgets(scriptcommand,500,ptr);
        stripCRLF(scriptcommand);
//        errorCode = interpreter(scriptcommand);
    }

    fclose(ptr);
}

/*******************************************************************************/
/*	Function setQuanta: Sets the Quanta for the CPU's Run-time-environment
/*	
/*	Input: 
/*      - qanta(global variable)   1 quanta = 1 instruction per CPU cycle
/*      - commandline[]: user input
/*******************************************************************************/


int setQuanta(char commandline[])
{   // Since the largest quanta allowed is 9, the max lenght of the user input is [QUANTA X]=8 characters
    // Also, reading ASCII char as an integer: [ASCII]49 = [int]1 and [ASCII]57 = [int]9

    if((strlen(commandline) > 8)|| commandline[7] < 49 || commandline[7] > 57)
	{
		printf("Error, quanta has to be a value bigger than 0 and < 9.\n");
		printf("Quanta is still set to %d\n", quanta);      // If invalid user input, quanta is unchanged
		return quanta;                                      // Exit the function
	}
    
    // Length of quanta stored in 8th element of user input
    quanta = commandline[7] - 48;	                        // Since reading char; we need to convert ASCII value to decimal
    printf("Quanta has been set to '%d'\n", quanta);
	return quanta;
}


/*******************************************************************************/
/*  DELETED
/*	Function concurent: Sets the number of programs that can run at the same time
/*	Global Variable (Default = 9)
/*	Next best thing to a linked list :p
/*	Not implemented yet...
/*******************************************************************************/

/*
int setconcurrent(char commandline[])
{

// If command is longer than 12 digits, or ASCII value of 12th item < (49=1) or > (57 = 9)
    if((strlen(commandline) > 12)|| commandline[11] < 49 || commandline[11] > 57)
	{
		printf("Error, CONCURRENT has to be a value between 1 and 9.\n");
		printf("CONCURRENT has remained set to %d\n", CONCURRENT);
		return CONCURRENT;
	}
    
   
    CONCURRENT = commandline[11] - 48;		// Since reading char; we need to convert ASCII value to decimal
    printf("CONCURRENT has been set to '%d'\n", quanta);
    return CONCURRENT;
	
}
*/





/*******************************************************************************/
/*	Function Pushterminate: Pushes the PID of a PCB into the Terminate Queue
/*      Since we only allow 10 processes to run at the same time, 
/*      the terminate Q can allow 10 members, and it gets cleard every CPU cycles
/*      the list can never overflow
/*
/*	Inputs:
/*		- PID: PID of the process ready for termination 
/*******************************************************************************/
void PushTerminate(PID)
{
    int i;
	for(i=0; i<9;i++)					    // Now scan the Queue from start to end looking for next empty spot
	    {
    		if(terminateQ[i] == -1)         // If no PCB at Queue location 
                {
                    terminateQ[i] = PID;
                    break;
        	     }
        }
}




/*******************************************************************************/
/*	Function PushReadyQueue: Pushes a PCB into the Ready Queue
/*
/*	Inputs:
/*		- readyHead: Pointer to the Head of the Ready queue (declared globally)
/*
/*	Output:
/*		- Pointer to the progream in ready Queue (used as a PID) 
/*******************************************************************************/

int PushReadyQueue(PID)
{
	int i;
    if(readyQ[readyHead] == -1)             // Therefore readyHead is pointing to an empty spot
      {
        readyQ[readyHead] = PID;            // Pushes the PID in the Q
//        printf("PID 0x0%d Pushed into Ready Q at spot R[0%d]\n", PID, readyHead);
        if(readyHead == 9)                  // Since we only allow up to 10 PCBs, condition implies that
                readyHead = 0;              // we reached the end of the Queue; need to wrap arround to find space
        else if(readyHead < 9)
        readyHead += 1;                     // Pointer to head of ready Q is incremented s.t. it points to first empty spot
    	return 0;                           // Exit function and return 0 = ok!
      }

		return -1;						    // No empty spot in the list; returns error code
}// End PushReadyQueue


/*Implementation using pointers
void PushReadQueue()
{
	
	//PCBtoPush = &((*PCBtoPush)->next); 
	//PCBtoPush->next = NULL;					    // PCBtoPush pointer to next points to null
	printf("got in the f1\n");
	//headReady->next = PCBtoPush;					// The old element at head of Ready points to PCB to Push
	printf("got in the f2\n");
	//headReady = *PCBtoPush;						// Hear of Ready list points to newPCB
	printf("got in the f3\n");

}// End PushReadQueue




/*******************************************************************************/
/*	Function PopReadyQueue: Pops a PCB from the ready Q
/*
/*	Inputs:
/*		- readyTail: (global) pointer to the tail of the ready Queue
/*		
/*	Output:
/*		- PID of the poped element 
/*******************************************************************************/


int PopReadyQueue()
{
	int popedPID;
	popedPID = readyQ[readyTail];					    // Tail points to the last element of the Q

    if(popedPID != -1)
        {

            readyQ[readyTail] = -1;                     // Empty spot in the Q
	        readyTail +=1;	    						// Push the tail of the Q one element forward

        // Since we implemented a circular list and porgrams are queued on a FIFO basis form the 
        // lowers pointer (0) to the highest (9) then looping back 
	        if(readyTail == 10)
                readyTail = 0;              	       	// Means we reached the end of the Queue => 
        }                                               // need to wrap arround to see if there is space
	  
	return popedPID;	    						    // return Queue pointer as a PID
} // End PopReadyQueue()




/*******************************************************************************/
/*	Function createPCB: Creates a PCB for 'program'
/*
/*	Inputs:
/*		-RAMptr: "pointer" to start of program in RAM (since RAM is an array; address = int)
/*		-filename: Name of the program
/*		-lenght: number of RAM cells occupied by program (number of commands)
/*
/*	Output: 
/*		PID: not a real PID, since it represents where in the Ready Q the 
/*		PCB is sitting, but good ennough to refer to a process since
/*		only 1 process can be at one PCB at a time
/*
/*  Retunr: PID or -1 if error
/*******************************************************************************/


int createPCB(int RAMptr, char filename[], int length)
{	
	int i;
	int PID = -1;                                   

    if(readyQ[readyHead] == -1)                             // If there is room in the readyQ
        {
        	for(i=0; i <=50; i++)                           // Insert File name; could have used strncpy.
    	     {PCB[readyHead].filename[i] = filename[i];}		
        	PCB[readyHead].start = RAMptr;					// Address in RAM with start of the program	
        	PCB[readyHead].current	= RAMptr;				// Since not executing yet, current = start 
        	PCB[readyHead].length = length;					// Given to us when we looked for empty space
	        memset(PCB[readyHead].memory, '\0', sizeof(PCB[readyHead].memory));		// Formats memory
            PID = readyHead;                                // Assign PID
            printf("'%s' has been assigned PID: '0x0%d'\n", filename, PID);
        	PushReadyQueue(PID);   				            // 'Pushing' the PBC into the Ready list
        }
    else
        {
            printf("Too many programs running at the moment...\n");
            printf("Try to run this again later!\n\n");
        }

	return PID;
}// End createPCB

/*Implementation using pointers
void createPCB(int RAMptr, char filename[], int length)
{	
	int i=0;

	struct PCB *newPCB;						// Creast a data structure allocate memory for new PCB
	newPCB = malloc(sizeof(struct PCB));
	for(i=0; i <=50; i++)newPCB->filename[i] = filename[i];		// Insert File name
	newPCB->start = RAMptr;						// Address in RAM with start of the program	
	newPCB->current	= RAMptr;					// Since not executing yet, current = start
	newPCB->length = length;					// Given to us when we looked for empty space
	memset(newPCB->memory, '\0', sizeof(newPCB->memory));		// Formats memory to avoid accidental collision
	printf("Done!\n");
	printf("Pushing PCB in Ready Queue...\n");	
	PushReadQueue(&newPCB);						// Pushes new PCB in Ready Queue
	printf("Done!\n");
}// End createPCB
*/


/*******************************************************************************/
/*	Function terminateprocesses: Terminates all processes in terminateQ
/*      Since the Q gets cleared every CPU cycle, don't need to worry about 
/*      implementing Queue for fairness
/*
/*	Inputs: terminateQ (Global)
/*
/*	Output: N/A
/*******************************************************************************/


void TerminateProcesses()
{
	int i, j, k, PID;                                   

    for(i=0; i <= 9; i++)                                       // Look at every elements in the Q 
        {
            PID = terminateQ[i];                                // Extract element to be terminates                           
            if(PID != -1)                                       // If we found a valid PID that needs termination 
                {
                  	printf("Terminating PID: 0x0%d\n", PID);    // Implemented while debugging, kept Just for fun...
                    for(k=0; (k <=20 && PCB[PID].memory[k] != NULL); k++)               // Scan every non empty memory cells of the PCB
                        {              
                            for(j=0;(j<100 && shellMemoryVar[j] != NULL);j++)           // Comapre every SHELL memory variable with the PCB's variables
                            {
                                if (strcmp(PCB[PID].memory[k],shellMemoryVar[j])==0)    // When we find a match
                                    {
                                        printf("DELETING '%s=%s' from Shell Memory\n",shellMemoryVar[j],shellMemoryData[j]);
                                        free(shellMemoryVar[j]);                        // Free the memory
                                        shellMemoryVar[j] = '\0';                       // And set to NULL
                                        free(shellMemoryData[j]);
                                        shellMemoryData[j] = '\0';
                                        break;
                                    }
                             }
                        }
                    
                    for(k=0; k <= PCB[PID].length; k++)         // Delete instructions from RAM
                        FREERAM[(PCB[PID].start+k)] = NULL; 
                    for(j=0; j <=20; j++)                       // Delete File name
    	                PCB[PID].filename[j] = '\0';	        // Format filename		
                 	PCB[PID].start = 0;					        // Reset Data	
                	PCB[PID].current = 0;			 
                	PCB[PID].length = 0;			

        	        memset(PCB[PID].memory, '\0', sizeof(PCB[PID].memory));		// Formats PCB memory
                	printf("Done terminating PID: 0x0%d\n", PID);               // Implemented while debugging, kept Just for fun...
              }// End if PID = -1
        terminateQ[i] = -1;                                     // Empty the Q
        }
}



/*******************************************************************************/
/*	Function storeInRAM: 
/*		- Finds space in RAM and stores program script. Because of
/*		  the nature of the algorithm used, RAM will be filled 
/*		  by programs from the back to the front. (Doesn't matter
/*		  but worth mentionning)
/*		- Calls functions to initiate PCB
/*		- Push new PCB in Ready Queue
/*
/*	Inputs: 
/*	   - filename[]: contains the script file's name
/*
/*  Returns:
/*     - PID (redy Queue index) or -1 if not ennough room in RAM to store
/*******************************************************************************/
int storeInRAM(char filename[])
{
    int i,j,k;
    int RAMptr = 120;
    int scanningRAM = 1;
    int scriptLenght=0;		
    char scriptcommand[100];
    int PID;
    FILE *ptr;
  


    if((ptr = fopen(filename,"rt")) == NULL)            // Open the file and check if valid
        {
            printf("Can't open script file\n");         // Notyfy user and return error code -1
            return -1;                                  
        }


   // Find space in RAM
    while(!feof(ptr))	            					// Compute the space needed in RAM
    {
        fgets(scriptcommand,500,ptr);                   // Counts the rows filled with text of file
	if(scriptcommand[0] != '\n')scriptLenght++;		    // To avoid counting empty rows
    }

    scriptLenght--;                                     // Since we counted one too many
    printf("Program in '%s' is %d instructions long.\n",filename,scriptLenght);
    printf("Searching RAM for Space");                // Created for debugging, kept for fun.
     
    while(scanningRAM)                                  // BOOL scanningRAM = 1 when function initiated
    {
    for(j=0; j<(100-scriptLenght); j++)				    // Scan RAM memory array for empty spot
     {				
	if(FREERAM[j] == '\0')					            // Found an empty slot in RAM
	    {	                                            // Print out the address in RAM
		    printf("\nFound a spot in RAM at address 0x0");
            if(j < 10)printf("0");                      // Created for debugging, kept just for fun :)
            if(j<100)printf("0");
            printf("%d; checking if big ennough...",j);

		    k=0;		                        
		    for(i=0; i<=scriptLenght; i++)              // Counts the contigeous free slots in RAM
		        {if(FREERAM[j+i] == '\0')k++;}		    // until we found ennough room for the script
		    if(k==(scriptLenght+1))				        // If there is ennough space; (+1 because counting 0)
		        {		
			        RAMptr = j;	            			// Save the location of first empty spot in RAM
			        scanningRAM = 0;		        	// Get out of the Scanning RAM loop
                    printf("ok!\n");
			        break;                              // Breaks out of for loop s.t. scanningRAM=0 can take effect
		        }// End if k=scriptLenght
	    }// End if(FREERAM[j] == '\0')	
      }// End of for(j=0; j<k; j++)
    }// End of while(scanningRAM)

     if(RAMptr == 120)                                  // Var declared at 120. If(still 120) = didn't find a spot in RAM
	{
		printf("Not ennough space in RAM to store script; get a bigger machine!\n");
		return -1;                                      // Returns error code & user warning of what went wrong 
	}

// If there is ennough space in RAM, program gets here

	printf("Creating PCB\n");

	PID = createPCB(RAMptr, filename, scriptLenght);	// Creates PCB and pushes it at the head of ready Q
	if(PID == -1)                                       // Warns user of cause of error
         return -1;                                     // If PID couldn't be created, Exit function



    if(RAMptr <=100)	
	{    
	     rewind(ptr);					                // Rewinds ptr to start of the file
    	 while(!feof(ptr))
		    {
		       fgets(scriptcommand,100,ptr);
	           stripCRLF(scriptcommand); 		        // Clean up command
               FREERAM[j] = strdup(scriptcommand);      // j = RAMpointer. Used to preserve the value of RAMptr
               j++;
		   }// End while(!eof)
     }// End if we found space in RAM
	fclose(ptr);
   	printf("Process initiation completed!\n\n");                                // Implemented while debugging, kept Just for fun...

// Program is in RAM; PCB is in Ready Queue and will be executed during CPU run-time; all tasks are done
	return PID;

}// END of storeInRAM function


/*******************************************************************************/
/*	Function run: 
/*      - Initiates the command 'RUN'
/*      - Extracts filename(s) from user input
/*      - calls soreinRAM (described above) for every filenames found
/*	
/*	Inputs: 
/*	   - userInput[]: contains the script file's name
/*******************************************************************************/

int run(char userInput[])
{
	int i, j=0;
	char filename[200];


// Extract the file name	    
    for(i=4;i<200 && userInput[i]!='\0';i++)	// Loops through i, starting at the first space until we get to '\0'
        {
            filename[j] = userInput[i]; 	    // Extract the filename from the user input
            j++;
            if(userInput[i]==' ')		        // Means there is more than one file name
		        {                               // Need to store the first one in RAM
		            filename[j-1] = '\0';			// Complete the file name
          	        storeInRAM(filename);		// Extract script script data, store in RAM and create PCB
		            j = 0;				        // Resets j counter for next filename
		        }// End if userinput = ' ' 
	    }// End for loop

// For the last file name of the RUN command; j counter hasen't been reset = file script not processed yet
	if(j!=0)  
	{
	   filename[j] = '\0';			            // Complete the file name
       storeInRAM(filename);	    	        // Extract script script data, store in RAM and create PCB
	}          
	return 0;
}// End run();



/*******************************************************************************/
/*	Function: Command line interpreter
/*	
/*	Changed since shell.h:
/*		RUN: ENNABLE virtual CPU Running of multiple 'programs'
/*		ECHO: Echos on the screen what follows
/*		EXIT: definition was extended to (EXIT or LOGOUT) 
/*******************************************************************************/

int interpreter(char userInput[], int Running)
{
    char response;
    int i, j;
    char extraChars[10];
    if (verbose)
    {
        printf("Verbose mode: Confirm execution of %s. (y/n): ",userInput);
        scanf("%c",&response);
        fgets(extraChars,10,stdin);
	stripCRLF(extraChars);
        if (response == 'N' || response == 'n')
        {
            printf("Operation cancelled\n");
            return 0;
        }
    }

    if (strcmp(userInput,"EXIT")==0 || strcmp(userInput,"LOGOUT")==0)
        return -1;
    else if (strcmp(userInput,"CLS")==0)
    {
        for (i=0;i<30;i++) printf("\n");
    }
    else if (strcmp(userInput,"HELP")==0)
    {
        printf("\n\nmyshell Command Set\n\n");
        printf("EXIT            to terminate the shell\n");
        printf("CLS             to clear the screen\n");
        printf("HELP            displays this help screen\n");
        printf("VERBOSE ON/OFF  to toggle verbose mode\n");
        printf("SET VAR VALUE   add a variable to shell memory\n");
        printf("GET VAR         see the value of a shell memory var\n");
        printf("SCRIPT FILENAME execute a script\n");
	printf("QUANTA [int]	sets quanta time to [int] (default = 3)\n");
        printf("PROMPT VALUE    change your prompt\n");
        printf("\n");
    }
    else if (strcmp(userInput,"VERBOSE ON")==0)
        verbose = TRUE;
    else if (strcmp(userInput,"VERBOSE OFF")==0)
        verbose = FALSE;
    else if (strcmp(userInput,"GET")==0)
    {
        printf("Shell Memory Variables\n");
        for(i=0;i<100 && shellMemoryVar[i]!=NULL;i++)
        {
            printf("%s=%s\n",shellMemoryVar[i],shellMemoryData[i]);
        }
    }
    else if (strncmp(userInput,"GET",3)==0)
        displayMemVar(userInput);
    else if (strncmp(userInput,"SET",3)==0)
        setMemVar(userInput, Running);
    else if (strncmp(userInput,"PROMPT",6)==0)
        changePrompt(userInput);
    else if (strncmp(userInput,"SCRIPT",6)==0)
        execute(userInput);
/****************************************************/
/*	new additions: RUN, ECHO, QUANTA, CONCURRENT
/****************************************************/
    else if (strncmp(userInput,"RUN",3)==0)
	    run(userInput);
    else if (strncmp(userInput,"ECHO",4)==0)
	{
		for(i=5;i<200 && userInput[i]!='\0';i++)
			{putchar(userInput[i]);}
		printf("\n");
	}
   else if (strncmp(userInput,"QUANTA",6)==0)
	setQuanta(userInput);
/********DELETED*************************************/
/*  CONCURRENT function not implemented yet, 
/*  but code is written and ready!
/****************************************************/
/*    else if (strncmp(userInput,"CONCURRENT ",11)==0)
	setconcurrent(userInput)
*/
    else
        system(userInput);

    return 0;
}



/*******************************************************************************/
/*	Function: shell()
/*	
/*	The main command-line control loop
/*******************************************************************************/


int shell()
{
    int i, errorResult=0;
    char response;
    char userInput[200];
    int Running = 15;               // Tells the interpreter that the shell is sending the command 

    // Display the command-line prompt
    printf("%s", userPrompt);
    fgets(userInput,200,stdin);
	stripCRLF(userInput);
    errorResult = interpreter(userInput, Running);

    return errorResult;
}



/****************************************************/
/*	Function: switches()
/*
/*	inputs:
/*		argc 	= argv[] element count
/*		argv[] 	= contains all the arguments inputed
/*			argv[0]	= 	launchcpde
/*			argv[1] = 	parameter1
/*			argv[n] = 	parametern
/*			argv[n+1] =	null
/*
/*	outputs:
/*		Returns 0 if no inputs => Programm launches
/*		Returns 1 if an argument was inputed => Program terminates
/*		Returns -1 if illegal argument input => Program terminates
/*
/*	Function:
/*		Acts on decoded argument
/*
/*
/****************************************************/
int switches(int argc, char **argv)
{
	if(argc == 0)return 0;						//No launch option, function returns 0 to main

	int i;							

	for( i = 1; i <= argc; i++ )				//Scan through arguments; argv[argc]=null
     {
       switch((int)argv[i][0] )					//Check for '-'
       {
       case '-':					    		//Found '-'; interprets the option
       		if(strlen(argv[i]) > 2)				//Argument should be 2 character long; '-x'
            	{
					printf("Invalid lenght for parameter %d; program has terminated...\n\n", i);
					break;
				}

			switch((int)argv[i][1])				//scans the 1st letter of arguments after '-'
                {
                   case 'h':					//Found the option -h; displaying help
					   puts("\nOption '-h' => Displaying Launch Parameters\n"
					        "To launch the OS, input 'os' -[argument] from the command line.\n"
							"Type 'os -h' to display help file\n"
							"The operating system was NOT launched...\n\n");
							return 1;       	//Tells main that valid option was found
                            break;				//Not nescessary.

                   default:						//If no valid launch parameter have been found
				 		printf( "-%c is not a valid launch parameter\n", argv[i][1]);
                        return -1;				//Informs main that user input illegal launch parameter
                        break;
                 }// End of scanning -[parameter]

			break;// End of case '-'; no legal parameter calls have been found

       default:		    						//If parameter doesn't start with '-'; illegal
	   		puts("Illegal syntax: launch parameter must start with '-'\n"
				 "OS was not launched...\n\n");
			return -1;
            break;
		}// End of switch loop scanning parameters
      }// End of for loop scanning parameters
return -1;				    				    //The program shouldn't be able to get here
}//End of function switches()







/*******************************************************************************/
/*	Function: TaskSwitchIn(Running, CPUptr)
/*
/*
/*	Inputs:
/*		- Running: 'pointer' (int) to the PBC that got poped from ready Q and gets to run
/*		- CPUptr: real pointer to the CPU => defined as a strucu in main()
/*
/*	Outputs:
/*		None
/*
/*	Function: Transfer the information from PCB to CPU
/*	Returns: None
/*
/*	*remember Datatypes definitions:
/*     PCB(char filename[50], int start, int length, int current, char *memory[20], struct PCB *next)
/*	CPU(int quanta, int returnCode,	int pc,	char *memory[20])
/*******************************************************************************/

void TaskSwitchIn(struct cpu *CPUptr, int Running)
{
	int i;	
	CPUptr->quanta = quanta;					// Reset quanta before starting job
	CPUptr->returnCode = 0;						// Reset CPU return code
	CPUptr->pc = PCB[Running].current;      	// Set the PC to where it left off
}


/*******************************************************************************/
/*	Function: TaskSwitchOUT(Running, CPUptr)
/*
/*
/*	Inputs:
/*		- Running: 'pointer' (int) to the PBC that got poped from ready Q and gets to run
/*		- CPUptr: pointer to the CPU => defined as a strucu in main()
/*
/*	Outputs:
/*		None
/*
/*	Function: Transfer the information from CPU to PBC
/*	Returns: None
/*
/*	*remember Datatypes definitions:
/*     PCB(char filename[50], int start, int length, int current, char *memory[20], struct PCB *next)
/*	CPU(int quanta, int returnCode,	int pc,	char *memory[20])
/*******************************************************************************/

void TaskSwitchOut(struct cpu *CPUptr, int Running)
{
	int i;	
    PCB[Running].current = CPUptr->pc;                 	// Records PC
}





/****************************************************/
/*	Function: formatRAM()
/*
/*	inputs:
/*		char *FREERAM[100] (A global variable
/*
/*	outputs:
/*		NONE
/*
/*	Function:
/*		Initializes FREERAM array by formating every
/*		cells (sets every elements to NULL)
/*
/*	Returns:
/*		0 if everything went well
/*		1 if an error occured
/*
/****************************************************/
int formatRAM(void)
{
	puts("Formating RAM...");
	memset(FREERAM, '\0', sizeof(FREERAM));
	puts(" ...Done!\n\n");
	return 0;
}// End of function formatRAM()




/*******************************************************************************/
/*	Function: login
/*
/*	Inputs: 
/*      - pass.txt: External password file conatining 
/*          NAME1
/*          PASSWORD1
/*          NAME1
/*          PASSWORD2
/*          [...]
/*          END
/*
/*	Function:
/*		Prompts for a name and password whitch are matched with an encrypted text file
/*		containing all valid credentials
/*
/*	Returns:
/*		0 Invalid Name or Password
/*		1 Valid login credentials
/*
/*******************************************************************************/
int login(void)
{
	FILE *fp;
	int i = 0;	
	int havename;
	int havepassword;
	
    struct credentials
	{
		char name[15];
		char pass[15];
	}user, fromfile;
	memset(user.name, '\0', sizeof(user.name));		// Formated to avoid collision login with existing memory values
	memset(user.pass, '\0', sizeof(user.pass));		// Formated to avoid collision login with existing memory values

	logo();									        // Displays OS logo... functionally useless

	printf("\nLogin name: ");						// Name is restricted to 15 characters to avoid iostream buffer overflow
	fgets(user.name, 15, stdin);                    // Get user input name

	printf("Password: ");                           // Get user input password
	fgets(user.pass, 15, stdin);					// Password also restricted to 15 characters

/****************TO BE IMPLEMEMTED*****************************/
/* Code for not Echoing password letters when typed. 
/*WIll implement if I have time.
/**************************************************************/
/*
#include <termios.h>
#include <unistd.h>

int mygetch ( void )
{
  int ch;
  struct termios oldt, newt;
  tcgetattr ( STDIN_FILENO, &oldt );
  newt = oldt;
  newt.c_lflag &= ~( ICANON | ECHO );
  tcsetattr ( STDIN_FILENO, TCSANOW, &newt );
  ch = getchar();
  tcsetattr ( STDIN_FILENO, TCSANOW, &oldt );
  return ch;
}
*/
	if((fp = fopen("pass.txt","r"))==NULL)		    //Open the password file
		{
			puts("Cannot open password file!\n"		
				 "Please make sure you have a file named 'pass.txt'\n"
				 "containing login credentials in this directory.\n");
			return 0;
		}

/********************/
/*	Authentication	
/********************/


 	while (feof(fp) == 0)
  	{
		memset(fromfile.name, '\0', sizeof(fromfile.name));		// Format filename buffer avoid accidental
                                                                // login with existing memory values
    	fgets(fromfile.name, 15, fp);		        			// Read next record on pass.txt file
		havename = 1;	                						// Assume a valid user name until proven wrong
		for(i = 0; i < sizeof(user.name); i++)	        		// Check if valid user name
    		{
    			if(fromfile.name[i] != user.name[i])	        // Character by character analysis
    				{
                        havename=0;			                    // Any divergence between the 2 values 
						break;                                  // kicks the porogram out of this loop
                    }// End of looking for invalid name
		    }// End for(scanning name)

		if(havename)		                					// Still have valid name after matching with file values
			{							                        // We have to look for valid password
			memset(fromfile.pass, '\0', sizeof(fromfile.pass));	// Start by formating the password buffer
			fgets(fromfile.pass, 15, fp);	        			// Extract password string associated with name
			havepassword = 1;
			if(fclose(fp))puts("File close error.\n");	    	// Since user names unique, pass file is no longer needed

			while(havepassword)
				{
					for(i = 0; i < sizeof(user.pass); i++)	    // Scan for divergence between record and input passwords
						{
							if(fromfile.pass[i] != user.pass[i])// If != detected, invalid credentials = return 0
								{
									puts("\nInvalid password!\n\n");
									return 0;	                // Exit the function
								}
						}				
					puts("Loging in... ...\n");                 // Otherwise
					return 1;				                    // Code can only get here if divergence not detected
				}// End of havepassword
			}// End of havename; wrong password; function should have already terminated
	}// Reached EOF without finding a valid user name

	puts("\nInvalid user name\n\n");
	if(fclose(fp))puts("File close error.\n");	    			//Close the password file
	return 0;								                    //Return 0 by default
}//End of login script










int main (int argc, char *argv[])
{

	int returnCode = 1;
    int progEnd, i;
    char instruction[100];

/****************Step 1: Check for switches***********************************/
/*	switches are found, calls the function switches which deals with them
/*	switches():
/*		if -h => returns -1 if -h was inputed; program terminates as required
/*		otherwise => returns 0; OS is loaded
/*****************************************************************************/

	if(--argc){if(switches(argc, argv))return -1;}

	puts("No switches detected, launching OS\n\n");



/****************Step 2: Initialize RAM***************************************/
/*	RAM is implemented using the global *FREERAM
/*	It contains 100 cells
/*
/*	The function formatRAM() will format the RAM
/*		Returns 0 if format went well
/*		Returns 1 if an error occured
/******************************************************************************/


	if(formatRAM())puts("WARNING!\n\nThe OS detected an error while formating RAM");



/****************Step 3: Initialize Run-Time Environment************************/
/*		3.1 Definition of PCB data type and creation of struct PCB is done globally
/*			Initialization of queue pointers.
/******************************************************************************/

    for(i=0; i<10; i++)                             // Initialization of Queues
        {
            readyQ[i] = -1;                         // -1 is used to indicate an empty spot (since all PIDs are >= 0
            terminateQ[i] = -1;
        }

	readyHead = 0;							        // Initialization of Q pointers
    readyTail = 0;                              
	int PIDRunning;								    // Variable to Identify Running PCB


/*Using pointers...
	struct PCB *tailReady;							// Head ready Q pointer already defined globally
	tailReady = headReady;							// Pointer to tail of Ready Q. Only used BY CPU for poping
	struct PCB * tailTerminate;						// Head terminate Q already defined Globally
	tailTerminate = headTerminate;						// Pointer to tail of Terminate Q. Only used BY CPU for poping
	struct PCB *running;							// Points to the currently executing script
	running = malloc(sizeof(struct PCB));
*/




/*******************************************************************************/
/*
/*	3.2 Initialization of Virtual CPU with a DATA structure
/*	Defined globally:
/*	struct cpu
/*		{
/*		int quanta; int returnCode;
/*		int pc;
/*		char *memory[20];						// Since the PCBs only have 20 memory cells
/*		};
/*******************************************************************************/

	struct cpu CPU;
	struct cpu *CPUptr;
	CPUptr = &CPU;	

	CPU.quanta = quanta; 							    // The value of quanta can be set by user
	CPU.returnCode = 0;
	CPU.pc = 0;
	memset(CPU.memory, '\0', sizeof(CPU.memory));




/****************Step 4: Run-Time Environment**********************************/

while(!login());						            	        //Can only pass this step if valid credentials
   {
   printf("Loading shell\n\n");

   while (returnCode != -1)
     {  
        printf("\n");                                           // Just for esthetics
	    returnCode = shell();	 					            // returns -1 when user inputs EXIT or LOGOUT
   	    PIDRunning = PopReadyQueue();                           // Pops next PCB from ready Q
        if(PIDRunning == -1)                                    // There is nothing left in the ready Q
            {
                readyHead = 0;                                  // Reset the Q pointers
                readyTail = 0;
            }
        if(PIDRunning != -1)
            {

                printf("CPU is running PID 0x0%d (called '%s')\n", PIDRunning, PCB[PIDRunning].filename); 
	            TaskSwitchIn(CPUptr, PIDRunning);	    		// Sets PC, pops variable from 'stack' to 'CPU registers'
	            CPU.quanta = quanta; 					        // Recursive step because this is done in TaskSwitchIn()...
                while(CPU.quanta > 0)                           // while Quanta left	       
              	   {

                      CPU.returnCode = interpreter(FREERAM[CPU.pc], PIDRunning);    // Send command and PCB memory address		
              		  CPU.pc +=1;					                        		// Increment CPU program counter		

        
                      progEnd = PCB[PIDRunning].start + PCB[PIDRunning].length;     // Compute where the program ends
                      if(CPU.returnCode == -1 || CPU.pc == progEnd)                 // Condition that program is done running
                    	   {    
                                printf("Done executing or reached EXIT/LOGOUT command.\n\n", PIDRunning);
                    	    	PushTerminate(PIDRunning);	                        // Pushes the program into the terminate Queue
                    			break;				                                // Break out of CPU quanta loop
                    	   }
                    	CPU.quanta --;						                        // Decrement CPU quanta
                    }// End of CPU Quanta					
	        TaskSwitchOut(CPUptr, PIDRunning);                  // Save runtinme environment in PCB 
            if(CPU.returnCode != -1 && CPU.pc != progEnd)       // Condition that program is still running
	            PushReadyQueue(PIDRunning);                     // Pushes current program into the Ready Q

        TerminateProcesses();
            }// End if(PIDRunning != -1)


    }// End while returncode!=-1


}//End while loged in
                                       // OS Overhead Services
	puts("Logging out of the shell and exiting OS\n");

	return 0;

}


// Just for fun, because programing gets boring after a while...
void logo(void)
{
puts("\n"
"           (((\n"
"           {  '>\n"
"           / ,)\n"
"          /_/ /\n"
"==========//=n===========\n"
"         /\n\n"
"    WELCOME TO BIRDX\n\n");
}

